package banco.clientes;

/**
 * Ttulo: CadastroClientes 
 *
 * @author Alexandra Barros
 * @version 1.0
 */

public class CadastroClientes {

  RepositorioClientes clientes;

  public CadastroClientes(RepositorioClientes clientes) {
    this.clientes = clientes;
  }

  public void cadastrar(Cliente cliente) throws ClienteExistenteException{
    this.clientes.inserir(cliente);
  }

  public void remover(String cpf) throws ClienteInexistenteException {
    this.clientes.remover(cpf);
  }

  public void atualizar(Cliente cliente) throws ClienteInexistenteException{
    this.clientes.atualizar(cliente);
  }

  public boolean existe(String cpf){
    return this.clientes.existe(cpf);
  }

  public Cliente procurar(String cpf) throws ClienteInexistenteException{
    return this.clientes.procurar(cpf);
  }
}