package banco.contas;

/**
 * Ttulo: CadastroContas
 * Descrio: Engloba as funcionalidades do repositrio de contas
 *
 * @author Alexandra Barros
 * @version 1.0
 */

public class CadastroContas {

  RepositorioContas contas;

  public CadastroContas(RepositorioContas contas) {
    this.contas = contas;
  }

  public void cadastrar(ContaAbstrata conta) throws ContaExistenteException{
    this.contas.inserir(conta);
  }

  public void remover(String numero) throws ContaInexistenteException {
    this.contas.remover(numero);
  }

  public void atualizar(ContaAbstrata conta) throws ContaInexistenteException{
    this.contas.atualizar(conta);
  }

  public boolean existe(String numero){
    return this.contas.existe(numero);
  }

  public ContaAbstrata procurar(String numero) throws ContaInexistenteException{
    return this.contas.procurar(numero);
  }

  public void creditar(String numero, double valor)
      throws ContaInexistenteException{
    this.contas.creditar(numero, valor);
  }

  public void debitar(String numero, double valor)
      throws ContaInexistenteException, SaldoInsuficienteException{
    this.contas.debitar(numero, valor);
  }

  public void transferir(String origem, String destino, double valor)
      throws ContaInexistenteException, SaldoInsuficienteException{
    this.transferir(origem, destino, valor);
  }
}