package banco.contas;

/**
 * Ttulo: ContaAbstrata
 *
 * @author Alexandra Barros
 * @version 1.0
 */

public abstract class ContaAbstrata {

  private String numero;
  private double saldo;

  public ContaAbstrata(String numero, double saldo) {
    this.numero = numero;
    this.saldo = saldo;
  }

  public String getNumero(){
    return this.numero;
  }

  public double getSaldo(){
    return this.saldo;
  }

  public void setNumero(String numero){
    this.numero = numero;
  }

  public void setSaldo(double saldo){
    this.saldo = saldo;
  }

  public void creditar(double valor){
    this.saldo = this.saldo + valor;
  }

  public abstract void debitar(double valor) throws SaldoInsuficienteException;

  public void transferir(ContaAbstrata contaDestino, double valor)
      throws SaldoInsuficienteException{

    this.debitar(valor);
    contaDestino.creditar(valor);
  }

}