package banco.contas;

/**
 * Ttulo: RepositorioContas 
 *
 * @author Alexandra Barros
 * @version 1.0
 */

public interface RepositorioContas {

  public void inserir(ContaAbstrata conta) throws ContaExistenteException;

  public void remover(String numero) throws ContaInexistenteException;

  public ContaAbstrata procurar(String numero)
      throws ContaInexistenteException;

  public void atualizar(ContaAbstrata conta) throws ContaInexistenteException;

  public boolean existe(String numero);

  public void creditar(String numero, double valor)
      throws ContaInexistenteException;

  public void debitar(String numero, double valor)
      throws ContaInexistenteException, SaldoInsuficienteException;

  public void transferir(String origem, String destino, double valor)
      throws ContaInexistenteException, SaldoInsuficienteException;

}