package banco.fachada;

/**
 * Ttulo: Fachada
 * Descrio: Engloba todas as funcionalidades do sistema 
 *
 * @author Alexandra Barros
 * @version 1.0
 */

import banco.clientes.*;
import banco.contas.*;

public class Fachada {

  private CadastroClientes clientes;
  private CadastroContas contas;
  private static Fachada fachada;

  public Fachada(){
    initCadastros();
  }

  public static Fachada getInstancia(){
    fachada = new Fachada();
    return fachada;
  }

  private void initCadastros(){

    ArrayClientes arrayClientes = new ArrayClientes();
    this.clientes = new CadastroClientes(arrayClientes);

    ArrayContas arrayContas = new ArrayContas();
    this.contas = new CadastroContas(arrayContas);
  }

  public void cadastrarConta(ContaAbstrata conta) throws ContaExistenteException{
    this.contas.cadastrar(conta);
  }

  public void removerConta(String numero) throws ContaInexistenteException{
    this.contas.remover(numero);
  }

  public void atualizarConta(ContaAbstrata conta) throws ContaInexistenteException{
    this.contas.atualizar(conta);
  }

  public ContaAbstrata procurarConta(String numero) throws ContaInexistenteException{
    return this.contas.procurar(numero);
  }

  public void creditarEmConta(String numero, double valor)
      throws ContaInexistenteException{
    this.contas.creditar(numero, valor);
  }

  public void debitarEmConta(String numero, double valor)
      throws ContaInexistenteException, SaldoInsuficienteException{
    this.contas.debitar(numero, valor);
  }

  public void transferir(String origem, String destino, double valor)
      throws ContaInexistenteException, SaldoInsuficienteException{
    this.contas.transferir(origem, destino, valor);
  }

}