package banco.fachada;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * Ttulo: FramePrincipal
 * Descrio: Representa o frame principal da aplicao
 *
 * @author Alexandra Barros
 * @version 1.0
 */

public class FramePrincipal extends JFrame {
 
  private JPanel contentPane;
  private JMenuBar menuBar = new JMenuBar();
  private JMenu menu = new JMenu();
  private PanelCadastro panelCadastro;
  private PanelCreditos panelCreditos;
  private PanelProcura panelProcura;
  private Fachada fachada;
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  JMenuItem menuItem1 = new JMenuItem();
  JMenuItem menuItem2 = new JMenuItem();  
  JMenuItem menuItem3 = new JMenuItem();

  /**Construct the frame*/
  public FramePrincipal(Fachada fachada) {
    this.fachada = fachada;
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    
    panelCadastro = new PanelCadastro(this.fachada);
    panelCreditos = new PanelCreditos(this.fachada);
	panelProcura = new PanelProcura(this.fachada);
	panelCadastro.setBounds(new Rectangle(0, 0, 400, 300));
	panelCreditos.setBounds(new Rectangle(0, 0, 400, 300));
	panelProcura.setBounds(new Rectangle(0, 0, 400, 300));
	
	contentPane = (JPanel) this.getContentPane();    
    contentPane.setLayout(null);    
    this.setSize(new Dimension(400, 300));
    this.setTitle("Caixa Bancrio");
	
	this.setJMenuBar(menuBar);
    menu.setText("Funcionalidades");
    
	menuItem1.addMouseListener(new MenuCadastrarActionListener(this));
	menuItem1.setText("Cadastro de Contas");
    
    menuItem2.addMouseListener(new MenuCreditosActionListener(this));
	menuItem2.setText("Creditar e Debitar em Conta");
	
	menuItem3.addMouseListener(new MenuProcuraActionListener(this));
	menuItem3.setText("Procura por Contas");
	
	menuBar.setFont(new java.awt.Font("Dialog", 0, 14));
    menuBar.setBorder(null);
    menuBar.setBounds(new Rectangle(10, 10, 0, 2));    
    menuBar.add(menu);
    
    menu.add(menuItem1);
    menu.add(menuItem2);
	menu.add(menuItem3);
  }
  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void menuItem1_mouseReleased(MouseEvent e) {
    this.setContentPane(panelCadastro);
    panelCadastro.setVisible(true);
  }

  void menuItem2_mouseReleased(MouseEvent e) {
    this.setContentPane(panelCreditos);
    panelCreditos.setVisible(true);
  }

  void menuItem3_mouseReleased(MouseEvent e) {
    this.setContentPane(panelProcura);
    panelProcura.setVisible(true);
  }
}

class MenuCadastrarActionListener extends java.awt.event.MouseAdapter{
  FramePrincipal adaptee;
  public MenuCadastrarActionListener(FramePrincipal adaptee){
	this.adaptee = adaptee;
  }
  public void mouseReleased(MouseEvent e) {
	this.adaptee.menuItem1_mouseReleased(e);
  }
}

class MenuCreditosActionListener extends java.awt.event.MouseAdapter{
  FramePrincipal adaptee;
  public MenuCreditosActionListener(FramePrincipal adaptee){
    this.adaptee = adaptee;
  }
  public void mouseReleased(MouseEvent e) {
    this.adaptee.menuItem2_mouseReleased(e);
  }
}

class MenuProcuraActionListener extends java.awt.event.MouseAdapter{
  FramePrincipal adaptee;
  public MenuProcuraActionListener(FramePrincipal adaptee){
	this.adaptee = adaptee;
  }
  public void mouseReleased(MouseEvent e) {
	this.adaptee.menuItem3_mouseReleased(e);
  }
}