package banco.fachada;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import banco.contas.*;


/**
 * Ttulo: PanelCadastro
 * Descrio: Interface reponsvel pelo cadastro de contas
 *
 * @author Alexandra Barros
 * @version 1.0
 */

public class PanelCadastro extends JPanel {
  private JLabel jLabel1 = new JLabel();
  private JTextField numeroCadastro = new JTextField();
  private JLabel jLabel2 = new JLabel();
  private JTextField saldoCadastro = new JTextField();
  private JButton cadastrar = new JButton();
  private Fachada fachada;

  public PanelCadastro(Fachada fachada) {
    this.fachada = fachada;
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }
  void jbInit() throws Exception {
    jLabel1.setText("Numero:");
    jLabel1.setBounds(new Rectangle(27, 90, 60, 17));
    this.setLayout(null);
    numeroCadastro.setBounds(new Rectangle(112, 88, 105, 21));
    jLabel2.setText("Saldo inicial:");
    jLabel2.setBounds(new Rectangle(27, 119, 76, 17));
    saldoCadastro.setBounds(new Rectangle(112, 117, 105, 21));
    cadastrar.setText("Cadastrar");
    cadastrar.setBounds(new Rectangle(247, 97, 108, 27));
    cadastrar.addActionListener(new BotaoCadastrarActionListener(this));
    this.add(jLabel1, null);
    this.add(jLabel2, null);
    this.add(saldoCadastro, null);
    this.add(numeroCadastro, null);
    this.add(cadastrar, null);
  }

  void cadastrar_actionPerformed(ActionEvent e) {

    try{
      double saldo = Double.parseDouble(saldoCadastro.getText());
      ContaAbstrata conta = new Conta(numeroCadastro.getText(), saldo);
      this.fachada.cadastrarConta(conta);
      JOptionPane.showMessageDialog(this, "A conta foi cadastrada com sucesso!", "Ateno",
          JOptionPane.INFORMATION_MESSAGE);
          numeroCadastro.setText("");
          saldoCadastro.setText("");
    }
    catch(NumberFormatException exc){
      JOptionPane.showMessageDialog(this, "Valor invlido para o saldo!", "Erro",
          JOptionPane.ERROR_MESSAGE);
    }
    catch(ContaExistenteException cee){
      JOptionPane.showMessageDialog(this, "Conta j criada!", "Erro",
          JOptionPane.ERROR_MESSAGE);
    }
  }
}

class BotaoCadastrarActionListener implements java.awt.event.ActionListener{

  PanelCadastro adaptee;

  public BotaoCadastrarActionListener(PanelCadastro adaptee){
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    this.adaptee.cadastrar_actionPerformed(e);
  }
}