package banco.fachada;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import banco.contas.*;

/**
 * Ttulo: PanelCadastro
 * Descrio: Interface responsvel pelas operaes de creditar e debitar
 *
 * @author Alexandra Barros
 * @version 1.0
 */

public class PanelCreditos extends JPanel {

  private JLabel jLabel1 = new JLabel();
  private JTextField numero = new JTextField();
  private JLabel jLabel2 = new JLabel();
  private JTextField saldo = new JTextField();
  private JButton creditar = new JButton();
  private Fachada fachada;
  JButton debitar = new JButton();

  public PanelCreditos(Fachada fachada) {
    this.fachada = fachada;
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }
  void jbInit() throws Exception {
    jLabel1.setText("Numero da conta:");
    jLabel1.setBounds(new Rectangle(27, 90, 108, 17));
    this.setLayout(null);
    numero.setBounds(new Rectangle(135, 87, 105, 21));
    jLabel2.setText("Valor:");
    jLabel2.setBounds(new Rectangle(27, 119, 76, 17));
    saldo.setBounds(new Rectangle(135, 116, 105, 21));
    creditar.setText("Creditar");
    creditar.setBounds(new Rectangle(25, 176, 108, 27));
    creditar.addActionListener(new BotaoCreditarActionListener(this));
    debitar.addActionListener(new BotaoDebitarActionListener(this));
    debitar.setBounds(new Rectangle(133, 176, 108, 27));
    debitar.setText("Debitar");
    this.add(jLabel1, null);
    this.add(jLabel2, null);
    this.add(numero, null);
    this.add(saldo, null);
    this.add(debitar, null);
    this.add(creditar, null);
  }

  void creditar_actionPerformed(ActionEvent e) {
    try{
      double valor = Double.parseDouble(saldo.getText());
      this.fachada.creditarEmConta(numero.getText(), valor);
      JOptionPane.showMessageDialog(this, "Crdito realizado com sucesso!", "Ateno",
          JOptionPane.INFORMATION_MESSAGE);
      numero.setText("");
      saldo.setText("");
    }
    catch(NumberFormatException nfe){
      JOptionPane.showMessageDialog(this, "Valor invlido para o saldo!", "Erro",
          JOptionPane.ERROR_MESSAGE);
    }
    catch(ContaInexistenteException exc){
      JOptionPane.showMessageDialog(this, "Essa conta no esta cadastrada!", "Erro",
          JOptionPane.ERROR_MESSAGE);
    }
  }
  void debitar_actionPerformed(ActionEvent e) {
    try{
      double valor = Double.parseDouble(saldo.getText());
      this.fachada.debitarEmConta(numero.getText(), valor);
      JOptionPane.showMessageDialog(this, "Dbito realizado com sucesso!", "Ateno",
          JOptionPane.INFORMATION_MESSAGE);
      numero.setText("");
      saldo.setText("");
    }
    catch(NumberFormatException nfe){
      JOptionPane.showMessageDialog(this, "Valor invlido para o saldo!", "Erro",
          JOptionPane.ERROR_MESSAGE);
    }
    catch(ContaInexistenteException exc){
      JOptionPane.showMessageDialog(this, "Essa conta no esta cadastrada!", "Erro",
          JOptionPane.ERROR_MESSAGE);
    }
    catch(SaldoInsuficienteException exc){
      double s = exc.getSaldo();
      JOptionPane.showMessageDialog(this, "A operao no pode ser efetuada!\n" +
      "Motivo: saldo insuficiente.\n"
      + "Conta nmero: " + exc.getNumero() + "\nSaldo: " + exc.getSaldo(), "Erro",
          JOptionPane.ERROR_MESSAGE);
    }
  }
}

class BotaoCreditarActionListener implements java.awt.event.ActionListener{

  PanelCreditos adaptee;

  public BotaoCreditarActionListener(PanelCreditos adaptee){
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    this.adaptee.creditar_actionPerformed(e);
  }
}
class BotaoDebitarActionListener implements java.awt.event.ActionListener{

  PanelCreditos adaptee;

  public BotaoDebitarActionListener(PanelCreditos adaptee){
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    this.adaptee.debitar_actionPerformed(e);
  }
}