package banco.fachada;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import banco.contas.*;


/**
 * Ttulo: PanelProcura
 * Descrio: Interface responsvel pela procura de contas 
 *
 * @author Alexandra Barros
 * @version 1.0
 */

public class PanelProcura extends JPanel {
  
  private JLabel jLabel1 = new JLabel();
  private JTextField numeroConta = new JTextField();   
  private JButton procurar = new JButton();
  private Fachada fachada;

  public PanelProcura(Fachada fachada) {
    this.fachada = fachada;
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }
  void jbInit() throws Exception {
    
    jLabel1.setText("Numero da conta:");
    jLabel1.setBounds(new Rectangle(70, 90, 100, 20));
    
    this.setLayout(null);
    
    numeroConta.setBounds(new Rectangle(170, 90, 100, 20));   
    
    procurar.setText("Procurar");
    procurar.setBounds(new Rectangle(150, 150, 110, 27));
    procurar.addActionListener(new BotaoProcurarActionListener(this));
    
    this.add(jLabel1, null);
    this.add(numeroConta, null);
    this.add(procurar, null);
  }

  void cadastrar_actionPerformed(ActionEvent e) {

    try{
     
      ContaAbstrata conta = this.fachada.procurarConta(numeroConta.getText());  
      numeroConta.setText("");    
      String numero = conta.getNumero();
      double saldo = conta.getSaldo();  
      JOptionPane.showMessageDialog(this, "Conta nmero: " + numero + "\n"
      	  + "Saldo: " + saldo, "Resultado da procura",
          JOptionPane.INFORMATION_MESSAGE);
          numeroConta.setText("");         
    }
    catch(ContaInexistenteException cee){
      JOptionPane.showMessageDialog(this, "Conta inexistente", "Erro",
          JOptionPane.ERROR_MESSAGE);
    }
  }
}

class BotaoProcurarActionListener implements java.awt.event.ActionListener{

  PanelProcura adaptee;

  public BotaoProcurarActionListener(PanelProcura adaptee){
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    this.adaptee.cadastrar_actionPerformed(e);
  }
}